/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlrechtspruefung.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="WAHLRECHTSPRUEFUNG.CountWahlvorschlagStatus",
     query="SELECT COUNT(o) FROM Wahlrechtspruefung o WHERE o.wahlvorschlag = ?1 AND o.wahlrechtspruefStatus IN (?2)",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLRECHTSPRUEFUNG.Kandidatur",
     query="SELECT o FROM Wahlrechtspruefung o WHERE o.kandidatur = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLRECHTSPRUEFUNG.KandidaturNotNullAndPruefkriteriumAndBemerkungIsBlank",
     query="SELECT w FROM Wahlrechtspruefung w LEFT JOIN Listenkandidatur l ON w.kandidatur.id =l.id WHERE w.kandidatur IS NOT NULL AND w.pruefkriterium=?1 AND w.wahlrechtspruefStatus=?2 AND l.liste.gruppeImGebiet.gruppe=?3 AND (w.bemerkung IS NULL OR w.bemerkung= '')",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLRECHTSPRUEFUNG.KandidaturNotNullAndPruefkriteriumAndBemerkung",
     query="SELECT w FROM Wahlrechtspruefung w LEFT JOIN Listenkandidatur l ON w.kandidatur.id =l.id WHERE w.kandidatur IS NOT NULL AND w.pruefkriterium=?1 AND w.wahlrechtspruefStatus=?2 AND w.bemerkung=?3 AND l.liste.gruppeImGebiet.gruppe=?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLRECHTSPRUEFUNG.Wahl",
     query="SELECT o FROM Wahlrechtspruefung o WHERE o.pruefkriterium.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLRECHTSPRUEFUNG.WahlvorschlagAndKandidaturIsNull",
     query="SELECT o FROM Wahlrechtspruefung o WHERE o.wahlvorschlag = ?1 AND o.kandidatur IS NULL",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="WAHLRECHTSPRUEFUNG.Wahlvorschlag",
     query="SELECT o FROM Wahlrechtspruefung o WHERE o.wahlvorschlag = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLRECHTSPRUEFUNG")
// @javax.persistence.IdClass(WahlrechtspruefungPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Wahlrechtspruefung
extends AbstractWahlrechtspruefung
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Wahlrechtspruefung() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Wahlrechtspruefung(Wahlrechtspruefung original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wahlrechtspruefung_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Wahlrechtspruefung")
    @javax.persistence.TableGenerator(name = "Wahlrechtspruefung", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Wahlrechtspruefung", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WahlrechtspruefungPK pkCache;

  @Override
  public WahlrechtspruefungPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WahlrechtspruefungPK(getId());
    }

    return pkCache;
  }

  public static <E extends Wahlrechtspruefung> java.util.Map<WahlrechtspruefungPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WahlrechtspruefungPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Wahlrechtspruefung> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBemerkung = false;
          hasChangedFristInTagenBisZurWahl = false;
          hasChangedWahlrechtspruefStatus = false;
  
      hasChangedKandidatur = false;
        hasChangedPruefkriterium = false;
        hasChangedWahlvorschlag = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BEMERKUNG", nullable = WahlrechtspruefungConstants.BEMERKUNG_NULLABLE, length=WahlrechtspruefungConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBemerkung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBemerkung;
  
  /**
   * 
   *
   * getter for WAHLRECHTSPRUEFUNG.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for WAHLRECHTSPRUEFUNG.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, WahlrechtspruefungConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


             if (!isSeitLadenVeraendertBemerkung) {
          isSeitLadenVeraendertBemerkung = thisAttributChanged;
         if (isSeitLadenVeraendertBemerkung){
           wertNachLadenBemerkung=this.bemerkung;
         }
       }
      

       this.bemerkung = bemerkungInternal;

         }

        
  @javax.persistence.Column(name = "FRIST_IN_TAGEN_BIS_ZUR_WAHL", nullable = WahlrechtspruefungConstants.FRIST_IN_TAGEN_BIS_ZUR_WAHL_NULLABLE, precision=WahlrechtspruefungConstants.FRIST_IN_TAGEN_BIS_ZUR_WAHL_PRECISION, scale=WahlrechtspruefungConstants.FRIST_IN_TAGEN_BIS_ZUR_WAHL_SCALE)
            
  protected java.lang.Long fristInTagenBisZurWahl =  null;

  @javax.persistence.Transient
  protected boolean hasChangedFristInTagenBisZurWahl = false;

  public boolean hasChangedFristInTagenBisZurWahl(){
    return hasChangedFristInTagenBisZurWahl;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertFristInTagenBisZurWahl = false;
     @javax.persistence.Transient
     private transient java.lang.Long wertNachLadenFristInTagenBisZurWahl;
  
  /**
   * 
   *
   * getter for WAHLRECHTSPRUEFUNG.FRIST_IN_TAGEN_BIS_ZUR_WAHL
   */
  @javax.annotation.Nullable   @Override   public  java.lang.Long getFristInTagenBisZurWahl() {
        return fristInTagenBisZurWahl;
      }

  /**
   * 
   *
   * setter for WAHLRECHTSPRUEFUNG.FRIST_IN_TAGEN_BIS_ZUR_WAHL
   *
   * @param fristInTagenBisZurWahl
   */
  @Override   public void setFristInTagenBisZurWahl(@javax.annotation.Nullable  java.lang.Long fristInTagenBisZurWahl) {

       resetTkCache();
                  java.lang.Long fristInTagenBisZurWahlInternal = fristInTagenBisZurWahl;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.fristInTagenBisZurWahl
      , fristInTagenBisZurWahlInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedFristInTagenBisZurWahl |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("fristInTagenBisZurWahl");
      }


             if (!isSeitLadenVeraendertFristInTagenBisZurWahl) {
          isSeitLadenVeraendertFristInTagenBisZurWahl = thisAttributChanged;
         if (isSeitLadenVeraendertFristInTagenBisZurWahl){
           wertNachLadenFristInTagenBisZurWahl=this.fristInTagenBisZurWahl;
         }
       }
      

       this.fristInTagenBisZurWahl = fristInTagenBisZurWahlInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "WAHLRECHTSPRUEF_STATUS", nullable = WahlrechtspruefungConstants.WAHLRECHTSPRUEF_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus wahlrechtspruefStatus =  null;

  @javax.persistence.Transient
  protected boolean hasChangedWahlrechtspruefStatus = false;

  public boolean hasChangedWahlrechtspruefStatus(){
    return hasChangedWahlrechtspruefStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertWahlrechtspruefStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus wertNachLadenWahlrechtspruefStatus;
  
  /**
   * 
   *
   * getter for WAHLRECHTSPRUEFUNG.WAHLRECHTSPRUEF_STATUS
   */
    @Override   public  de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus getWahlrechtspruefStatus() {
        return wahlrechtspruefStatus;
      }

  /**
   * 
   *
   * setter for WAHLRECHTSPRUEFUNG.WAHLRECHTSPRUEF_STATUS
   *
   * @param wahlrechtspruefStatus
   */
  @Override   public void setWahlrechtspruefStatus( de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus wahlrechtspruefStatus) {

       resetTkCache();
                  de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus wahlrechtspruefStatusInternal = wahlrechtspruefStatus;
       
                de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus alterWert = getWahlrechtspruefStatus();
         wahlrechtspruefStatusInternal = preProcessWahlrechtspruefStatus(wahlrechtspruefStatusInternal);
         preSetWahlrechtspruefStatus(alterWert, wahlrechtspruefStatusInternal);
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlrechtspruefStatus
      , wahlrechtspruefStatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedWahlrechtspruefStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("wahlrechtspruefStatus");
      }


             if (!isSeitLadenVeraendertWahlrechtspruefStatus) {
          isSeitLadenVeraendertWahlrechtspruefStatus = thisAttributChanged;
         if (isSeitLadenVeraendertWahlrechtspruefStatus){
           wertNachLadenWahlrechtspruefStatus=this.wahlrechtspruefStatus;
         }
       }
      

       this.wahlrechtspruefStatus = wahlrechtspruefStatusInternal;

                postSetWahlrechtspruefStatus(alterWert, wahlrechtspruefStatusInternal);
         }

  
    @Override
    protected de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus preProcessWahlrechtspruefStatus(de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus neuerWert) {
      return super.preProcessWahlrechtspruefStatus(neuerWert);
    }

    @Override
    protected void preSetWahlrechtspruefStatus(de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus alterWert, de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus neuerWert) {
      super.preSetWahlrechtspruefStatus(alterWert, neuerWert);
    }

    @Override
    protected void postSetWahlrechtspruefStatus(de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus alterWert, de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus neuerWert) {
      super.postSetWahlrechtspruefStatus(alterWert, neuerWert);
    }
    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Kandidatur
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "KANDIDATUR_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.kandidatur.entity.Kandidatur kandidatur;

  /**
   * 
   */
  @Override
  public void setKandidatur(@javax.annotation.Nullable  de.ivu.elect.business.kandidatur.entity.Kandidatur kandidatur){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.kandidatur
    , kandidatur);

    attributeChanged |= thisAttributChanged;

    hasChangedKandidatur |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("kandidatur");
    }

    this.kandidatur = kandidatur;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.kandidatur.entity.Kandidatur getKandidatur(){
    return this.kandidatur;
  }

  @javax.persistence.Transient
  protected boolean hasChangedKandidatur = false;

  public boolean hasChangedKandidatur(){
    return hasChangedKandidatur;
  }

  /**
   * Beziehung (unidirektional) zu Pruefkriterium
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "PRUEFKRITERIUM_ID", referencedColumnName="PRUEFKRITERIUM_ID"))
  protected de.ivu.elect.business.wahlrechtspruefung.entity.Pruefkriterium pruefkriterium;

  /**
   * 
   */
  @Override
  public void setPruefkriterium( de.ivu.elect.business.wahlrechtspruefung.entity.Pruefkriterium pruefkriterium){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.pruefkriterium
    , pruefkriterium);

    attributeChanged |= thisAttributChanged;

    hasChangedPruefkriterium |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("pruefkriterium");
    }

    this.pruefkriterium = pruefkriterium;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahlrechtspruefung.entity.Pruefkriterium getPruefkriterium(){
    return this.pruefkriterium;
  }

  @javax.persistence.Transient
  protected boolean hasChangedPruefkriterium = false;

  public boolean hasChangedPruefkriterium(){
    return hasChangedPruefkriterium;
  }

  /**
   * Beziehung (unidirektional) zu Wahlvorschlag
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLVORSCHLAG_ID", referencedColumnName="WAHLVORSCHLAG_ID"))
  protected de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag;

  /**
   * 
   */
  @Override
  public void setWahlvorschlag( de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag wahlvorschlag){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahlvorschlag
    , wahlvorschlag);

    attributeChanged |= thisAttributChanged;

    hasChangedWahlvorschlag |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahlvorschlag");
    }

    this.wahlvorschlag = wahlvorschlag;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlag getWahlvorschlag(){
    return this.wahlvorschlag;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahlvorschlag = false;

  public boolean hasChangedWahlvorschlag(){
    return hasChangedWahlvorschlag;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Wahlrechtspruefung:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Wahlrechtspruefung other){
                             other.bemerkung = this.bemerkung;
                                other.fristInTagenBisZurWahl = this.fristInTagenBisZurWahl;
                                other.wahlrechtspruefStatus = this.wahlrechtspruefStatus;
           
  other.setKandidatur(this.getKandidatur());
  other.setPruefkriterium(this.getPruefkriterium());
  other.setWahlvorschlag(this.getWahlvorschlag());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Wahlrechtspruefung.class)){
        copyEntityAttributesUsingSetter((Wahlrechtspruefung) other.castTo(Wahlrechtspruefung.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Wahlrechtspruefung: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Wahlrechtspruefung other){
               other.setBemerkung(this.bemerkung);
                  other.setFristInTagenBisZurWahl(this.fristInTagenBisZurWahl);
                  other.setWahlrechtspruefStatus(this.wahlrechtspruefStatus);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Wahlrechtspruefung other){
                       if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedFristInTagenBisZurWahl) {
        other.setFristInTagenBisZurWahl(this.fristInTagenBisZurWahl);
      }
                             if (hasChangedWahlrechtspruefStatus) {
        other.setWahlrechtspruefStatus(this.wahlrechtspruefStatus);
      }
             }





    @javax.persistence.Transient
    private transient WahlrechtspruefungTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WahlrechtspruefungTK getWahlrechtspruefungTK(){
    if (tkCache==null) {
    tkCache = new WahlrechtspruefungTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlrechtspruefungTK();
    }

  @Override
  public WahlrechtspruefungUK getUk(){
    return getWahlrechtspruefungUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Wahlrechtspruefung.class;
  }

public WahlrechtspruefungUK getWahlrechtspruefungUK(){

   return  new WahlrechtspruefungUK(



  );
}

  @javax.persistence.Transient
  private transient WahlrechtspruefungProperties properties;

  public WahlrechtspruefungProperties getProperties(){
    if (properties == null) {
      properties = new WahlrechtspruefungProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlrechtspruefungProperties getWahlrechtspruefungProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlrechtspruefungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(WahlrechtspruefungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlrechtspruefungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL);

        bemerkung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlrechtspruefungConstants.MESSAGE_KEY_FRIST_IN_TAGEN_BIS_ZUR_WAHL_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlrechtspruefungConstants.MESSAGE_KEY_FRIST_IN_TAGEN_BIS_ZUR_WAHL_EINZAHL);

        fristInTagenBisZurWahl =
                        vorher.getAttributTyp().getValueAsLong(vorher.getWertVorher());
                  }

            
      if (werteVorher.containsKey(WahlrechtspruefungConstants.MESSAGE_KEY_WAHLRECHTSPRUEF_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlrechtspruefungConstants.MESSAGE_KEY_WAHLRECHTSPRUEF_STATUS_EINZAHL);

        wahlrechtspruefStatus =
     (de.ivu.elect.business.wahlrechtspruefung.entity.WahlrechtspruefStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBemerkung) {
      result.put(WahlrechtspruefungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBemerkung , bemerkung));
    }
                            if (isSeitLadenVeraendertFristInTagenBisZurWahl) {
      result.put(WahlrechtspruefungConstants.MESSAGE_KEY_FRIST_IN_TAGEN_BIS_ZUR_WAHL_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
                                    de.ivu.elect.jee.protokollierung.AttributTyp.LONG
                            , wertNachLadenFristInTagenBisZurWahl , fristInTagenBisZurWahl));
    }
                            if (isSeitLadenVeraendertWahlrechtspruefStatus) {
      result.put(WahlrechtspruefungConstants.MESSAGE_KEY_WAHLRECHTSPRUEF_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenWahlrechtspruefStatus , wahlrechtspruefStatus));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBemerkung = false;
      wertNachLadenBemerkung = null;
                          isSeitLadenVeraendertFristInTagenBisZurWahl = false;
      wertNachLadenFristInTagenBisZurWahl = null;
                          isSeitLadenVeraendertWahlrechtspruefStatus = false;
      wertNachLadenWahlrechtspruefStatus = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WAHLRECHTSPRUEFUNG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Wahlrechtspruefung";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlrechtspruefungConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, WahlrechtspruefungConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(WahlrechtspruefungConstants.FRIST_IN_TAGEN_BIS_ZUR_WAHL_MAX_VALUE, WahlrechtspruefungConstants.FRIST_IN_TAGEN_BIS_ZUR_WAHL_MIN_VALUE, fristInTagenBisZurWahl, this, WahlrechtspruefungConstants.MESSAGE_KEY_FRIST_IN_TAGEN_BIS_ZUR_WAHL_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(wahlrechtspruefStatus, this, WahlrechtspruefungConstants.MESSAGE_KEY_WAHLRECHTSPRUEF_STATUS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
